<template>
  <div class="row d-flex justify-content-center">
    <div class="col-lg-4 col-sm-12">
      <div class="card mt-4 mb-2">
        <div class="card-body">
          <video ref="me"></video>
          <p class="card-text mt-2">{{user.name}}</p>
        </div>
      </div>
    </div>
    <ChatUser v-for="(client, index) in clients" :key="index" :client="client" />
  </div>
</template>

<script>
import { mapGetters, mapMutations } from "vuex";
import ChatUser from "../components/ChatUser";
export default {
  props: {
    room: String
  },
  computed: {
    ...mapGetters({
      user: "getName",
      clients: "getClients"
    })
  },
  components: {
    ChatUser
  },
  mounted() {
    window.webrtc.joinRoom(this.$route.params.room);

    window.webrtc.on("videoAdded", (video, peer) => {
      this.addPeer({ video, peer });
    });

    window.webrtc.on("localStream", stream => {
      let attachMediaStream = require("attachmediastream");
      attachMediaStream(stream, this.$refs.me, {
        autoplay: true,
        mirror: true,
        muted: true
      });
    });
  },
  methods: {
    ...mapMutations({
      addPeer: "addPeer"
    })
  }
};
</script>

<style scoped>
video {
  width: 100%;
  height: 200px;
  background-color: rgba(0, 0, 0, 0.3);
}
</style>